onEvent('recipes', event => {

  // Meadow Dirt to Coarse Dirt
  event.shaped(Item.of("minecraft:coarse_dirt", 4), [
    ["byg:meadow_dirt", "minecraft:gravel", null],
    ["minecraft:gravel", "byg:meadow_dirt", null],
    [null, null, null],
  ])


  // Clayblock back to 4x Clay
  event.shapeless(Item.of('minecraft:clay_ball', 4), ['minecraft:clay'])



  // 3x Gravel to 1x Flint
  event.shapeless(Item.of('minecraft:flint'), ['minecraft:gravel', 'minecraft:gravel', 'minecraft:gravel'])



  // Beach Grass to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:beach_grass', 'byg:beach_grass'])



  // Short Beach Grass to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:short_beach_grass', 'byg:short_beach_grass'])



  // Cattail to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:cattail', 'byg:cattail'])



  // Leaf Pile to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:leaf_pile', 'byg:leaf_pile'])



  // Meadow Dirt to Dirt
  event.shapeless(Item.of('minecraft:dirt'), ['byg:meadow_dirt'])


  // Any Sand to Sand
  event.shapeless(Item.of('minecraft:sand'), ['#forge:sand'])


  // White Cherry Foliage to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:white_cherry_foliage', 'byg:white_cherry_foliage'])



  // Pink Foliage to Sticks recipe
  event.shapeless(Item.of('minecraft:stick'), ['byg:pink_cherry_foliage', 'byg:pink_cherry_foliage'])


  // Packing Tape Recipe
  event.remove({id: 'packingtape:tape'})
  event.shapeless(Item.of('packingtape:tape'), ['#forge:slimeballs', '#forge:string', 'minecraft:paper'])


  // DruidCraft - Oak Beam
  event.remove({output: 'druidcraft:oak_beam'})
  event.shaped(Item.of('druidcraft:oak_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:oak_log',
  })

  // DruidCraft - Dark Oak Beam
  event.remove({output: 'druidcraft:dark_oak_beam'})
  event.shaped(Item.of('druidcraft:dark_oak_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:dark_oak_log',
  })

  // DruidCraft - Spruce Beam
  event.remove({output: 'druidcraft:spruce_beam'})
  event.shaped(Item.of('druidcraft:spruce_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:spruce_log',
  })

  // DruidCraft - Birch Beam
  event.remove({output: 'druidcraft:birch_beam'})
  event.shaped(Item.of('druidcraft:birch_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:birch_log',
  })

  // DruidCraft - Jungle Beam
  event.remove({output: 'druidcraft:jungle_beam'})
  event.shaped(Item.of('druidcraft:jungle_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:jungle_log',
  })

  // DruidCraft - Acacia Beam
  event.remove({output: 'druidcraft:acacia_beam'})
  event.shaped(Item.of('druidcraft:acacia_beam', 3), [
    ' W ',
    ' W ',
    ' W '
  ], {
    W: 'minecraft:acacia_log',
  })


  // Angel Ring
event.remove({output: "angelring:itemring" })
  event.shaped(Item.of("angelring:itemring"), [
    ["forbidden_arcanus:bat_wing", "minecraft:gold_block", "forbidden_arcanus:bat_wing"],
    ["minecraft:gold_block", "angelring:itemdiamondring", "minecraft:gold_block"],
    ["forbidden_arcanus:golden_dragon_scale", "minecraft:gold_block", "forbidden_arcanus:golden_dragon_scale"],
  ])


  // Ultra Importer
  event.replaceInput(
    { id: "cabletiers:ultra_importer" },
    "cabletiers:elite_importer",
    "extrastorage:advanced_importer"
    )


  // Ultra Exporter
  event.replaceInput(
    { id: "cabletiers:ultra_exporter" },
    "cabletiers:elite_exporter",
    "extrastorage:advanced_exporter"
    )


  // Shrinking Device
  event.replaceInput(
    { id: "shrink:shrinking_device" },
    "#forge:glass",
    "immersiveengineering:circuit_board"
    )


  // Shrinking Device 2
  event.replaceInput(
    { id: "shrink:shrinking_device" },
    "minecraft:ender_pearl",
    "rftoolsbase:infused_enderpearl"
    )


  // Shrinking Device 3
  event.replaceInput(
    { id: "shrink:shrinking_device" },
    "minecraft:stone_button",
    "rftoolscontrol:cpu_core_1000"
    )


  // Shrinking Device 4
  event.replaceInput(
    { id: "shrink:shrinking_device" },
    "minecraft:iron_ingot",
    "#forge:ingots/compressed_iron"
    )



  // Diamond Ring
  event.replaceInput(
    { id: "angelring:itemdiamondring" },
    "minecraft:elytra",
    "enigmaticlegacy:fabulous_scroll"
    )


  // Ring of Ender
  event.replaceInput(
    { id: "enigmaticlegacy:ender_ring" },
    "enigmaticlegacy:iron_ring",
    "enigmaticlegacy:gem_ring"
    )



  // Building Gadget
event.remove({output: "buildinggadgets:gadget_building" })
  event.shaped(Item.of("buildinggadgets:gadget_building"), [
    ["minecraft:iron_ingot", "minecraft:redstone", "minecraft:iron_ingot"],
    ["minecraft:diamond", "rftoolscontrol:cpu_core_500", "minecraft:diamond"],
    ["minecraft:iron_ingot", "minecraft:lapis_lazuli", "minecraft:iron_ingot"],
  ])

  // Copy-Paste Gadget
event.remove({output: "buildinggadgets:gadget_copy_paste" })
  event.shaped(Item.of("buildinggadgets:gadget_copy_paste"), [
    ["minecraft:iron_ingot", "minecraft:redstone", "minecraft:iron_ingot"],
    ["minecraft:emerald", "rftoolscontrol:cpu_core_500", "minecraft:emerald"],
    ["minecraft:iron_ingot", "minecraft:lapis_lazuli", "minecraft:iron_ingot"],
  ])

  // Destruction Gadget
event.remove({output: "buildinggadgets:gadget_destruction" })
  event.shaped(Item.of("buildinggadgets:gadget_destruction"), [
    ["minecraft:iron_ingot", "minecraft:redstone", "minecraft:iron_ingot"],
    ["minecraft:ender_pearl", "rftoolscontrol:cpu_core_1000", "minecraft:ender_pearl"],
    ["minecraft:iron_ingot", "minecraft:lapis_lazuli", "minecraft:iron_ingot"],
  ])

  // Exchanging Gadget
event.remove({output: "buildinggadgets:gadget_exchanging" })
  event.shaped(Item.of("buildinggadgets:gadget_exchanging"), [
    ["minecraft:iron_ingot", "minecraft:redstone", "minecraft:iron_ingot"],
    ["minecraft:diamond", "minecraft:lapis_lazuli", "minecraft:diamond"],
    ["minecraft:iron_ingot", "rftoolscontrol:cpu_core_1000", "minecraft:iron_ingot"],
  ])

  // Template Manager
event.remove({output: "buildinggadgets:template_manager" })
  event.shaped(Item.of("buildinggadgets:template_manager"), [
    ["minecraft:gold_ingot", "minecraft:redstone", "minecraft:gold_ingot"],
    ["minecraft:emerald", "rftoolscontrol:cpu_core_2000", "minecraft:emerald"],
    ["minecraft:gold_ingot", "minecraft:lapis_lazuli", "minecraft:gold_ingot"],
  ])



  // Entangled Block
event.remove({output: "entangled:block" })
  event.shaped(Item.of("entangled:block"), [
    ["minecraft:ender_pearl", "minecraft:obsidian", "minecraft:ender_pearl"],
    ["minecraft:obsidian", "#forge:chests/wooden", "minecraft:obsidian"],
    ["minecraft:ender_pearl", "minecraft:obsidian", "minecraft:ender_pearl"],
  ])



  // Magnetism Ring
  event.shaped(Item.of('ringsofascension:ring_magnetism'), [
    ' I ',
    'IEI',
    'RIB'
  ], {
    I: 'minecraft:iron_ingot',
    E: 'minecraft:ender_pearl',
    R: '#forge:dyes/red',
    B: '#forge:dyes/blue'
  })



  // Pied Wool
  event.shaped(Item.of('rats:pied_wool'), [
    'WG ',
    'YW ',
    '   '
  ], {
    W: 'minecraft:white_wool',
    G: '#forge:dyes/green',
    Y: '#forge:dyes/yellow'
  })



  // Cursed Ring
  event.shaped(Item.of('enigmaticlegacy:cursed_ring'), [
    'GNH',
    'NRN',
    'ENE'
  ], {
    H: 'enigmaticlegacy:earth_heart',
    G: 'enigmaticlegacy:golem_heart',
    E: 'enigmaticlegacy:etherium_ingot',
    R: 'enigmaticlegacy:ender_ring',
    N: 'minecraft:netherite_ingot'
  })
  


  // Mining Dim - Block
    event.remove({id: 'mining_dimension:teleporter'})
    event.shaped(Item.of("mining_dimension:teleporter"), [
    ["minecraft:emerald", "#minecraft:logs", "minecraft:diamond"],
    ["#minecraft:logs", "minecraft:diamond_pickaxe", "#minecraft:logs"],
    ["minecraft:gold_block", "#minecraft:logs", "minecraft:iron_block"],
  ])



  // Dusts
  event.replaceOutput(
    { id: "engineerstools:crushing/uranium_grit_crushing_recipe" },
    "immersiveengineering:dust_uranium",
    "silents_mechanisms:uranium_dust"
    )



  // Tesseract
  event.remove({id: 'tesseract:tesseract'})
  event.shaped(Item.of('tesseract:tesseract'), [
    'OUF',
    'ATA',
    'FUO'
  ], {
    O: 'minecraft:obsidian',
    A: 'mekanism:alloy_atomic',
    F: 'fluxnetworks:flux_block',
    T: 'mekanism:teleportation_core',
    U: 'mekanism:ultimate_control_circuit'
  })



  // Warped Button
    event.remove({output: "variant16x:warped_hyphae_button" })
    event.shapeless(Item.of('variant16x:warped_hyphae_button'), ['#minecraft:wooden_buttons', '#minecraft:warped_stems'])

  // Crimson Button
    event.remove({output: "variant16x:crimson_hyphae_button" })
    event.shapeless(Item.of('variant16x:crimson_hyphae_button'), ['#minecraft:wooden_buttons', '#minecraft:crimson_stems'])

  // Dark Oak Button
    event.remove({output: "variant16x:dark_oak_wood_button" })
    event.shapeless(Item.of('variant16x:dark_oak_wood_button'), ['#minecraft:wooden_buttons', '#minecraft:dark_oak_logs'])

  // Acacia Button
    event.remove({output: "variant16x:acacia_wood_button" })
    event.shapeless(Item.of('variant16x:acacia_wood_button'), ['#minecraft:wooden_buttons', '#minecraft:acacia_logs'])

  // Jungle Button
    event.remove({output: "variant16x:jungle_wood_button" })
    event.shapeless(Item.of('variant16x:jungle_wood_button'), ['#minecraft:wooden_buttons', '#minecraft:jungle_logs'])

  // Birch Button
    event.remove({output: "variant16x:birch_wood_button" })
    event.shapeless(Item.of('variant16x:birch_wood_button'), ['#minecraft:wooden_buttons', '#minecraft:birch_logs'])

  // Spruce Button
    event.remove({output: "variant16x:spruce_wood_button" })
    event.shapeless(Item.of('variant16x:spruce_wood_button'), ['#minecraft:wooden_buttons', '#minecraft:spruce_logs'])

  // Oak Button
    event.remove({output: "variant16x:oak_wood_button" })
    event.shapeless(Item.of('variant16x:oak_wood_button'), ['#minecraft:wooden_buttons', '#minecraft:oak_logs'])


  
  // Forbidden And Arcanus - Batwing to Reliquary Batwing
    event.shapeless(Item.of('xreliquary:bat_wing'), ['forbidden_arcanus:bat_wing'])



  // Reliquary - Batwing Batwing to Forbidden And Arcanus Batwing
    event.shapeless(Item.of('forbidden_arcanus:bat_wing'), ['xreliquary:bat_wing'])


  // IE - Steel Sword
  event.replaceInput(
    { id: "immersiveengineering:crafting/sword_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )

  // IE - Steel Pickaxe
  event.replaceInput(
    { id: "immersiveengineering:crafting/pickaxe_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )

  // IE - Steel Shovel
  event.replaceInput(
    { id: "immersiveengineering:crafting/shovel_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )

  // IE - Steel Axe
  event.replaceInput(
    { id: "immersiveengineering:crafting/axe_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )

  // IE - Steel Hoe
  event.replaceInput(
    { id: "immersiveengineering:crafting/hoe_steel" },
    "#forge:ingots/steel",
    "#forge:plates/steel"
    )



  // Sythian Stalk to 2x Bamboo
  event.shaped(Item.of('minecraft:bamboo', 2), [
    ' S ',
    'SGS',
    ' S '
  ], {
    S: 'byg:sythian_stalk_block',
    G: 'minecraft:green_dye'
  })



  // Osmium Ore Chunks to Osmium Ingot
  event.smelting(Item.of('mekanism:ingot_osmium', 1), 'kubejs:osmium_chunks').xp(1.0)
  event.blasting(Item.of('mekanism:ingot_osmium', 1), 'kubejs:osmium_chunks').xp(1.0)



  // Yellorite Ore Chunks to Yellorium Ingot
  event.smelting(Item.of('bigreactors:yellorium_ingot', 1), 'kubejs:yellorite_chunks').xp(1.0)
  event.blasting(Item.of('bigreactors:yellorium_ingot', 1), 'kubejs:yellorite_chunks').xp(1.0)



  // Fruit Log to Charcoal
  event.smelting(Item.of('minecraft:charcoal', 1), 'simplefarming:fruit_log').xp(0.15)



  // MC Sweet Berries to Red Dye
  event.shapeless(Item.of('minecraft:red_dye'), ['minecraft:sweet_berries', 'minecraft:sweet_berries', 'minecraft:sweet_berries'])



  // BYG Blueberries to Blue Dye Fix
  event.remove({id: 'byg:blue_dye'})
  event.shapeless(Item.of('minecraft:blue_dye'), ['byg:blueberries', 'byg:blueberries', 'byg:blueberries'])



  // BYG Azalea to Light Blue Dye
  event.shapeless(Item.of('minecraft:light_blue_dye', 2), ['byg:azalea'])



  // Ars Nouveau Source Berry to Purple Dye
  event.shapeless(Item.of('minecraft:purple_dye'), ['ars_nouveau:mana_berry', 'ars_nouveau:mana_berry', 'ars_nouveau:mana_berry'])


  // Thermal - Flux Efficiency
  event.shaped(Item.of('thermal:machine_efficiency_augment'), [
    ' G ',
    'PCP',
    ' G '
  ], {
    G: '#forge:gears/iron',
    P: '#forge:plates/silver',
    C: 'thermal:rf_coil'
  })


  // Astral Sorcery - Marble Bricks Slab
  event.remove({id: 'astralsorcery:shaped/marble/marble_slab'})
  event.shaped(Item.of('astralsorcery:marble_slab', 6), [
    '   ',
    'BBB',
    '   '
  ], {
    B: 'astralsorcery:marble_bricks',
  })



  // Astral Sorcery - Marble Bricks Stairs
  event.remove({id: 'astralsorcery:shaped/marble/marble_stairs'})
  event.shaped(Item.of('astralsorcery:marble_stairs', 6), [
    'B  ',
    'BB ',
    'BBB'
  ], {
    B: 'astralsorcery:marble_bricks',
  })



  // Astral Sorcery - Sooty Marble Bricks Slab
  event.remove({id: 'astralsorcery:shaped/black_marble/black_marble_slab'})
  event.shaped(Item.of('astralsorcery:black_marble_slab', 6), [
    '   ',
    'BBB',
    '   '
  ], {
    B: 'astralsorcery:black_marble_bricks',
  })



  // Astral Sorcery - Sooty Marble Bricks Stairs
  event.remove({id: 'astralsorcery:shaped/black_marble/black_marble_stairs'})
  event.shaped(Item.of('astralsorcery:black_marble_stairs', 6), [
    'B  ',
    'BB ',
    'BBB'
  ], {
    B: 'astralsorcery:black_marble_bricks',
  })



  // PickleTweaks Watering Can
  event.remove({id: 'pickletweaks:watering_can'})
  event.shaped(Item.of('pickletweaks:watering_can'), [
    ' NI',
    'IBI',
    ' I '
  ], {
    N: 'minecraft:iron_nugget',
    I: 'minecraft:iron_ingot',
    B: 'minecraft:bowl'
  })



  // Loot Bag Pieces to Loot Bag
  event.shaped(Item.of("lootbagmod:lootbag"), [
    ["kubejs:lootbag_piece", "kubejs:lootbag_piece", "kubejs:lootbag_piece"],
    ["kubejs:lootbag_piece", "kubejs:lootbag_piece", "kubejs:lootbag_piece"],
    ["kubejs:lootbag_piece", "kubejs:lootbag_piece", "kubejs:lootbag_piece"],
  ])



  // ExtCaves Cobble Dirt Stone
  event.shaped(Item.of('extcaves:dirtstone_cobble', 4), [
    'CD ',
    'DC ',
    '   '
  ], {
    C: '#forge:cobblestone',
    D: 'minecraft:dirt'
  })



  // ExtCaves Dirt Stone
  event.shaped(Item.of('extcaves:dirtstone', 4), [
    'DS ',
    'SS ',
    '   '
  ], {
    S: '#forge:stone',
    D: 'minecraft:dirt'
  })



  // ExtCaves Ice Bricks
  event.shaped(Item.of('extcaves:bricks_ice', 4), [
    'PB ',
    'BP ',
    '   '
  ], {
    P: 'minecraft:packed_ice',
    B: 'minecraft:bricks'
  })



  // ExtCaves Lava Stone
  event.shaped(Item.of('extcaves:lavastone', 4), [
    'SM ',
    'SS ',
    '   '
  ], {
    M: 'minecraft:magma_block',
    S: '#forge:stone'
  })



  // ExtCaves Marlstone Powder
  event.shaped(Item.of('extcaves:marlstone_powder', 2), [
    'CM ',
    'MC ',
    '   '
  ], {
    M: 'byg:mud_ball',
    C: 'minecraft:clay'
  })



    // ExtCaves Marlstone in Furnace Recipe
  event.smelting(Item.of('extcaves:marlstone', 1), 'extcaves:marlstone_powder').xp(0.10)



  // ExtCaves Sediment Stone
  event.shaped(Item.of('extcaves:sedimentstone', 4), [
    'SC ',
    'CS ',
    '   '
  ], {
    C: 'extcaves:clay_lump',
    S: '#forge:stone'
  })



  // ExtCaves Snow Bricks
  event.shaped(Item.of('extcaves:bricks_snow', 4), [
    'SB ',
    'BS ',
    '   '
  ], {
    S: 'minecraft:snow_block',
    B: 'minecraft:stone_bricks'
  })



  // ExtCaves Snow Bricks Slab
  event.shaped(Item.of('extcaves:bricks_snow_slab', 6), [
    '   ',
    'SSS',
    '   '
  ], {
    S: 'extcaves:bricks_snow',
  })



  // ExtCaves Ice Bricks Slab
  event.shaped(Item.of('extcaves:bricks_ice_slab', 6), [
    '   ',
    'III',
    '   '
  ], {
    I: 'extcaves:bricks_ice',
  })



  // ExtCaves Cobble Dirt Slab
  event.shaped(Item.of('extcaves:dirtstone_cobble_slab', 6), [
    '   ',
    'DDD',
    '   '
  ], {
    D: 'extcaves:dirtstone_cobble',
  })



  // ExtCaves Dirt Stone Slab
  event.shaped(Item.of('extcaves:dirtstone_slab', 6), [
    '   ',
    'DDD',
    '   '
  ], {
    D: 'extcaves:dirtstone',
  })



  // ExtCaves Snow Bricks Stairs
  event.shaped(Item.of('extcaves:bricks_snow_stairs', 4), [
    'B  ',
    'BB ',
    'BBB'
  ], {
    B: 'extcaves:bricks_snow',
  })



  // ExtCaves Ice Bricks Stairs
  event.shaped(Item.of('extcaves:bricks_ice_stairs', 4), [
    'I  ',
    'II ',
    'III'
  ], {
    I: 'extcaves:bricks_ice',
  })



  // ExtCaves Cobble Dirt Stairs
  event.shaped(Item.of('extcaves:dirtstone_cobble_stairs', 4), [
    'D  ',
    'DD ',
    'DDD'
  ], {
    D: 'extcaves:dirtstone_cobble',
  })



  // ExtCaves Dirt Stone Stairs
  event.shaped(Item.of('extcaves:dirtstone_stairs', 4), [
    'S  ',
    'SS ',
    'SSS'
  ], {
    S: 'extcaves:dirtstone',
  })



  // Chain Plating BYG
  event.remove({id: 'byg:chain_plating'})
  event.shaped(Item.of('byg:chain_plating', 4), [
    'INI',
    'N N',
    'INI'
  ], {
    I: 'minecraft:iron_ingot',
    N: 'minecraft:iron_nugget'
  })



  // Stone Pebble
  event.remove({id: 'extcaves:pebble_stone'})
  event.shaped(Item.of('extcaves:pebble_stone', 18), [
    'S  ',
    'S  ',
    '   '
  ], {
    S: 'minecraft:stone',
  })



  // Extra Disks Stuff
  event.replaceInput(
    { id: "extradisks:part/65536k_storage_part" },
    "extradisks:16384k_storage_part",
    "extrastorage:storagepart_16384k"
    )

  event.replaceInput(
    { id: "extradisks:part/infinite_fluid_storage_part" },
    "extradisks:1048576k_fluid_storage_part",
    "extrastorage:storagepart_1048576k_fluid"
    )



  // BDB - Tall Water Reeds to Sticks
  event.shaped(Item.of('minecraft:stick'), [
    'R  ',
    'R  ',
    '   '
  ], {
    R: 'betterdefaultbiomes:tall_water_reeds',
  })



  // Flux Plug
  event.remove({output: "fluxnetworks:flux_plug" })
  event.shaped(Item.of('fluxnetworks:flux_plug', 2), [
    ' F ',
    'FTF',
    ' F '
  ], {
    F: 'fluxnetworks:flux_core',
    T: 'tesseract:tesseract'
  })



  // Flux Point
  event.remove({output: "fluxnetworks:flux_point" })
  event.shaped(Item.of('fluxnetworks:flux_point'), [
    ' F ',
    'FTF',
    ' F '
  ], {
    F: 'fluxnetworks:flux_core',
    T: 'mekanism:teleportation_core'
  })



    // Baked Potato to Baked Potato
  event.remove({output: 'pamhc2crops:bakedsweetpotatoitem'})
  event.smelting(Item.of('pamhc2crops:bakedsweetpotatoitem', 1), 'simplefarming:baked_sweet_potato').xp(0.35)
  event.smoking(Item.of('pamhc2crops:bakedsweetpotatoitem', 1), 'simplefarming:baked_sweet_potato').xp(0.35)
  event.recipes.minecraft.campfire_cooking('pamhc2crops:bakedsweetpotatoitem', 'simplefarming:baked_sweet_potato')



  // Assorted Vegetables
  event.remove({id: "rats:assorted_vegetables"})
  event.shaped(Item.of('rats:assorted_vegetables'), [
    'VVV',
    'VVV',
    'VV '
  ], {
    V: '#forge:vegetables',
  })



  // Maple Fence
  event.remove({id: "byg:maple_fence"})
  event.shaped(Item.of('byg:maple_fence', 3), [
    '   ',
    'PRP',
    'PRP'
  ], {
    R: '#forge:rods/wooden',
    P: 'byg:maple_planks'
  })



  event.replaceInput(
    { id: "byg:maple_fence_gate" },
    "minecraft:stick",
    "#forge:rods/wooden"
    )


  // Mystical Agriculture Enderium Essence Craft
  event.remove({id: "mysticalagriculture:essence/thermal/enderium_ingot"})
  event.shaped(Item.of('thermal:enderium_ingot', 2), [
    'EEE',
    'E E',
    'EEE'
  ], {
    E: 'mysticalagriculture:enderium_essence',
  })


  // Mystical Agriculture Lumium Essence Craft
  event.remove({id: "mysticalagriculture:essence/thermal/lumium_ingot"})
  event.shaped(Item.of('thermal:lumium_ingot', 4), [
    'LLL',
    'L L',
    'LLL'
  ], {
    L: 'mysticalagriculture:lumium_essence',
  })


  // Mystical Agriculture Signalum Essence Craft
  event.remove({id: "mysticalagriculture:essence/thermal/signalum_ingot"})
  event.shaped(Item.of('thermal:signalum_ingot', 4), [
    'SSS',
    'S S',
    'SSS'
  ], {
    S: 'mysticalagriculture:signalum_essence',
  })


  // Mystical Agriculture Constantan Essence Craft
  event.shaped(Item.of('thermal:constantan_ingot', 4), [
    'CCC',
    'C C',
    'CCC'
  ], {
    C: 'mysticalagriculture:constantan_essence',
  })



  // Mystical Agriculture Invar Essence Craft
  event.shaped(Item.of('thermal:invar_ingot', 4), [
    'III',
    'I I',
    'III'
  ], {
    I: 'mysticalagriculture:invar_essence',
  })



  // Mystical Agriculture Electrum Essence Craft
  event.shaped(Item.of('thermal:electrum_ingot', 4), [
    'EEE',
    'E E',
    'EEE'
  ], {
    E: 'mysticalagriculture:electrum_essence',
  })



  // Mystical Agriculture Bronze Essence Craft
  event.shaped(Item.of('thermal:bronze_ingot', 4), [
    'BBB',
    'B B',
    'BBB'
  ], {
    B: 'mysticalagriculture:bronze_essence',
  })



  // Mystical Agriculture Nickel Essence Craft
  event.shaped(Item.of('thermal:nickel_ingot', 4), [
    'NNN',
    'N N',
    'NNN'
  ], {
    N: 'mysticalagriculture:nickel_essence',
  })



  // Mystical Agriculture Silver Essence Craft
  event.shaped(Item.of('thermal:silver_ingot', 4), [
    'SSS',
    'S S',
    'SSS'
  ], {
    S: 'mysticalagriculture:silver_essence',
  })



  // Mystical Agriculture Lead Essence Craft
  event.shaped(Item.of('thermal:lead_ingot', 4), [
    'LLL',
    'L L',
    'LLL'
  ], {
    L: 'mysticalagriculture:lead_essence',
  })


  // Mystical Agriculture Tin Essence Craft
  event.shaped(Item.of('thermal:tin_ingot', 4), [
    'TTT',
    'T T',
    'TTT'
  ], {
    T: 'mysticalagriculture:tin_essence',
  })



  // Mystical Agriculture Copper Essence Craft
  event.shaped(Item.of('thermal:copper_ingot', 4), [
    'CCC',
    'C C',
    'CCC'
  ], {
    C: 'mysticalagriculture:copper_essence',
  })



  // Time in a Bottle
  event.remove({output: "tiab:timeinabottle" })
  event.shaped(Item.of('tiab:timeinabottle'), [
    'GTG',
    'DCD',
    'YBY'
  ], {
    G: 'minecraft:gold_block',
    D: 'minecraft:diamond',
    C: 'minecraft:clock',
    B: 'kubejs:timeless_bottle',
    T: 'minecraft:ghast_tear',
    Y: 'forbidden_arcanus:ender_pearl_fragment'
  })



  // Timeless Bottle
  event.shaped(Item.of('kubejs:timeless_bottle'), [
    ' L ',
    'GHG',
    ' G '
  ], {
    G: 'forbidden_arcanus:arcane_glass',
    H: 'supplementaries:hourglass',
    L: '#botania:petals/lime'
  })



  event.shaped(Item.of("appliedenergistics2:silicon", 6), [
    [null, "mysticalagriculture:silicon_essence", null], 
    [null, "mysticalagriculture:silicon_essence", null], 
    [null, "mysticalagriculture:silicon_essence", null],
  ])



  // Forbidden and Arcanus - Jar
  event.replaceInput(
    { id: "forbidden_arcanus:bottle_block" },
    "#minecraft:planks",
    "#minecraft:wooden_slabs"
    )


  // Supplementaries - Jar
  event.replaceInput(
    { id: "supplementaries:jar_recipe" },
    "#minecraft:wooden_slabs",
    "#minecraft:logs"
    )



  // Mystical Agriculture IF - Rubber Craft
  event.shaped(Item.of('industrialforegoing:dryrubber'), [
    ' R ',
    ' R ',
    ' R '
  ], {
    R: 'mysticalagriculture:rubber_essence',
  })



  // Mystical Agriculture Thermal - Rubber Craft
  event.shaped(Item.of('thermal:rubber', 2), [
    '   ',
    'RRR',
    '   '
  ], {
    R: 'mysticalagriculture:rubber_essence',
  })



  event.remove({id: "rats:plastic_smelting"})
  event.remove({id: "rats:plastic_blast_furnace"})
  event.smelting(Item.of('kubejs:tiny_plastic_piece', 1), 'rats:plastic_waste').xp(0.05)
  event.blasting(Item.of('kubejs:tiny_plastic_piece', 1), 'rats:plastic_waste').xp(0.05)



  // Processed Plastic
  event.shaped(Item.of("kubejs:processed_plastic"), [
    ["kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece"], 
    ["kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece"], 
    ["kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece", "kubejs:tiny_plastic_piece"],
  ])



  event.smelting(Item.of('industrialforegoing:plastic', 1), 'kubejs:processed_plastic').xp(0.05)
  event.blasting(Item.of('industrialforegoing:plastic', 1), 'kubejs:processed_plastic').xp(0.05)



  // Yellorium Nuggets
  event.shapeless(Item.of('kubejs:yellorium_nugget', 9), ['bigreactors:yellorium_ingot'])



  // Yellorium Ingot from Nugget
  event.shaped(Item.of("bigreactors:yellorium_ingot"), [
    ["kubejs:yellorium_nugget", "kubejs:yellorium_nugget", "kubejs:yellorium_nugget"], 
    ["kubejs:yellorium_nugget", "kubejs:yellorium_nugget", "kubejs:yellorium_nugget"], 
    ["kubejs:yellorium_nugget", "kubejs:yellorium_nugget", "kubejs:yellorium_nugget"],
  ])



  // Powered Anvil 1
  event.replaceInput(
    { id: "cyclic:anvil" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )



  // Powered Anvil 2
  event.replaceInput(
    { id: "cyclic:anvil" },
    "minecraft:iron_block",
    "#forge:storage_blocks/compressed_iron"
    )



  // Powered Anvil 3
  event.replaceInput(
    { id: "cyclic:anvil" },
    "minecraft:redstone",
    "silents_mechanisms:redstone_alloy_ingot"
    )



  // Magma Anvil 1
  event.replaceInput(
    { id: "cyclic:anvil_magma" },
    "minecraft:magma_block",
    "craftandhunt:blaze_glass_block"
    )

  // Magma Anvil 2
  event.replaceInput(
    { id: "cyclic:anvil_magma" },
    "minecraft:obsidian",
    "minecraft:crying_obsidian"
    )

  // Mason Steel
  event.replaceInput(
    { id: "cyclic:mason_steel" },
    "minecraft:iron_block",
    "#forge:storage_blocks/compressed_iron"
    )



  // Crystal Sword
  event.replaceInput(
    { id: "cyclic:crystal_sword" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )

  // Crystal Pickaxe
  event.replaceInput(
    { id: "cyclic:crystal_pickaxe" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )

  // Crystal Shovel
  event.replaceInput(
    { id: "cyclic:crystal_shovel" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )

  // Crystal Axe
  event.replaceInput(
    { id: "cyclic:crystal_axe" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )

  // Crystal Hoe
  event.replaceInput(
    { id: "cyclic:crystal_hoe" },
    "minecraft:diamond",
    "minecraft:diamond_block"
    )



  // Dusts to Dusts
  event.shapeless(Item.of('thermal:iron_dust'), ['#forge:dusts/iron'])
  event.shapeless(Item.of('thermal:gold_dust'), ['#forge:dusts/gold'])
  event.shapeless(Item.of('thermal:quartz_dust'), ['#forge:dusts/quartz'])
  event.shapeless(Item.of('thermal:copper_dust'), ['#forge:dusts/copper'])
  event.shapeless(Item.of('thermal:tin_dust'), ['#forge:dusts/tin'])
  event.shapeless(Item.of('thermal:lead_dust'), ['#forge:dusts/lead'])
  event.shapeless(Item.of('thermal:silver_dust'), ['#forge:dusts/silver'])
  event.shapeless(Item.of('thermal:nickel_dust'), ['#forge:dusts/nickel'])
  event.shapeless(Item.of('thermal:bronze_dust'), ['#forge:dusts/bronze'])
  event.shapeless(Item.of('thermal:electrum_dust'), ['#forge:dusts/electrum'])
  event.shapeless(Item.of('thermal:invar_dust'), ['#forge:dusts/invar'])
  event.shapeless(Item.of('thermal:constantan_dust'), ['#forge:dusts/constantan'])
  event.shapeless(Item.of('thermal:signalum_dust'), ['#forge:dusts/signalum'])
  event.shapeless(Item.of('thermal:lumium_dust'), ['#forge:dusts/lumium'])
  event.shapeless(Item.of('thermal:enderium_dust'), ['#forge:dusts/enderium'])



  // Nuggets to Nuggets
  event.shapeless(Item.of('thermal:copper_nugget'), ['#forge:nuggets/copper'])
  event.shapeless(Item.of('thermal:tin_nugget'), ['#forge:nuggets/tin'])
  event.shapeless(Item.of('thermal:lead_nugget'), ['#forge:nuggets/lead'])
  event.shapeless(Item.of('thermal:silver_nugget'), ['#forge:nuggets/silver'])
  event.shapeless(Item.of('thermal:nickel_nugget'), ['#forge:nuggets/nickel'])
  event.shapeless(Item.of('thermal:bronze_nugget'), ['#forge:nuggets/bronze'])
  event.shapeless(Item.of('thermal:electrum_nugget'), ['#forge:nuggets/electrum'])
  event.shapeless(Item.of('thermal:invar_nugget'), ['#forge:nuggets/invar'])
  event.shapeless(Item.of('thermal:constantan_nugget'), ['#forge:nuggets/constantan'])
  event.shapeless(Item.of('thermal:signalum_nugget'), ['#forge:nuggets/signalum'])
  event.shapeless(Item.of('thermal:lumium_nugget'), ['#forge:nuggets/lumium'])
  event.shapeless(Item.of('thermal:enderium_nugget'), ['#forge:nuggets/enderium'])



  // Pig Fat
  event.remove({id: 'extlights:pig_fat_craft'})
  event.shapeless(Item.of('extlights:pig_fat', 2), ['minecraft:porkchop', 'minecraft:porkchop'])



  // Quark Marble to Astral Marble and vice versa
  event.shapeless(Item.of('astralsorcery:marble_raw'), ['quark:marble'])
  event.shapeless(Item.of('quark:marble'), ['astralsorcery:marble_raw'])



  // AE2 - Calculation Press
  event.shaped(Item.of("appliedenergistics2:calculation_processor_press"), [
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"], 
    ["silentgems:chaos_iron_block", "appliedenergistics2:purified_certus_quartz_crystal", "silentgems:chaos_iron_block"], 
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"],
  ])

  // AE2 - Engineering Press
  event.shaped(Item.of("appliedenergistics2:engineering_processor_press"), [
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"], 
    ["silentgems:chaos_iron_block", "immersiveengineering:toolbox", "silentgems:chaos_iron_block"], 
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"],
  ])

  // AE2 - Logic Press
  event.shaped(Item.of("appliedenergistics2:logic_processor_press"), [
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"], 
    ["silentgems:chaos_iron_block", "rftoolsutility:logic", "silentgems:chaos_iron_block"], 
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"],
  ])

  // AE2 - Silicon Press
  event.shaped(Item.of("appliedenergistics2:silicon_press"), [
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"], 
    ["silentgems:chaos_iron_block", "#appliedenergistics2:silicon", "silentgems:chaos_iron_block"], 
    ["#forge:storage_blocks/compressed_iron", "silentgems:chaos_iron_block", "#forge:storage_blocks/compressed_iron"],
  ])



  // Uranium Stuff
  event.replaceInput(
    { id: "silents_mechanisms:metals/uranium_block" },
    "#forge:ingots/uranium",
    "silents_mechanisms:uranium_ingot"
    )

  event.replaceInput(
    { id: "silents_mechanisms:metals/uranium_nugget" },
    "#forge:ingots/uranium",
    "silents_mechanisms:uranium_ingot"
  )



  // Expanded Storage - Netherite Chest
  event.remove({id: 'expandedstorage:netherite_chest'})
  event.smithing('expandedstorage:netherite_chest', 'expandedstorage:obsidian_chest', 'minecraft:netherite_ingot')

  // Expanded Storage - Wood to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:wood_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:wood_to_netherite_conversion_kit', 'expandedstorage:wood_to_obsidian_conversion_kit', 'minecraft:netherite_ingot')

  // Expanded Storage - Obsidian to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:obsidian_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:obsidian_to_netherite_conversion_kit', 'minecraft:obsidian', 'minecraft:netherite_ingot')

  // Expanded Storage - Diamond to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:diamond_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:diamond_to_netherite_conversion_kit', 'expandedstorage:diamond_to_obsidian_conversion_kit', 'minecraft:netherite_ingot')

  // Expanded Storage - Gold to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:gold_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:gold_to_netherite_conversion_kit', 'expandedstorage:gold_to_obsidian_conversion_kit', 'minecraft:netherite_ingot')

  // Expanded Storage - Iron to Netherite Conversion Kit
  event.remove({id: 'expandedstorage:iron_to_netherite_conversion_kit'})
  event.smithing('expandedstorage:iron_to_netherite_conversion_kit', 'expandedstorage:iron_to_obsidian_conversion_kit', 'minecraft:netherite_ingot')



  // Craft and Hunt - Wither Sword
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_sword'})
  event.smithing('craftandhunt:wither_sword', 'craftandhunt:bone_sword', 'minecraft:wither_skeleton_skull')

  // Craft and Hunt - Wither Pickaxe
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_pickaxe'})
  event.smithing('craftandhunt:wither_pickaxe', 'craftandhunt:bone_pickaxe', 'minecraft:wither_skeleton_skull')

  // Craft and Hunt - Wither Shovel
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_shovel'})
  event.smithing('craftandhunt:wither_shovel', 'craftandhunt:bone_shovel', 'minecraft:wither_skeleton_skull')

  // Craft and Hunt - Wither Axe
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_axe'})
  event.smithing('craftandhunt:wither_axe', 'craftandhunt:bone_axe', 'minecraft:wither_skeleton_skull')

  // Craft and Hunt - Wither Hoe
  event.remove({id: 'craftandhunt:bone_upgraded_to_wither_hoe'})
  event.smithing('craftandhunt:wither_hoe', 'craftandhunt:bone_hoe', 'minecraft:wither_skeleton_skull')



  // Forbidden and Arcanus (CAH) - Wither Sword
  event.smithing('craftandhunt:wither_sword', 'forbidden_arcanus:bone_sword', 'minecraft:wither_skeleton_skull')

  // Forbidden and Arcanus (CAH) - Wither Pickaxe
  event.smithing('craftandhunt:wither_pickaxe', 'forbidden_arcanus:bone_pickaxe', 'minecraft:wither_skeleton_skull')

  // Forbidden and Arcanus (CAH) - Wither Shovel
  event.smithing('craftandhunt:wither_shovel', 'forbidden_arcanus:bone_shovel', 'minecraft:wither_skeleton_skull')

  // Forbidden and Arcanus (CAH) - Wither Axe
  event.smithing('craftandhunt:wither_axe', 'forbidden_arcanus:bone_axe', 'minecraft:wither_skeleton_skull')

  // Forbidden and Arcanus (CAH) - Wither Hoe
  event.smithing('craftandhunt:wither_hoe', 'forbidden_arcanus:bone_hoe', 'minecraft:wither_skeleton_skull')


  // Iron Chain
  event.remove({id: 'forbidden_arcanus:iron_chain'})
  event.shaped(Item.of('forbidden_arcanus:iron_chain', 3), [
    '  N',
    ' I ',
    'N  '
  ], {
    N: 'minecraft:iron_nugget',
    I: 'minecraft:iron_ingot'
  });



  // Druidcraft Bone Helmet
  event.remove({id: 'druidcraft:bone_helmet'})
  event.shaped(Item.of('druidcraft:bone_helmet'), [
    'BBB',
    'BFB',
    '   '
  ], {
    B: 'minecraft:bone',
    F: 'kubejs:bone_fragment'
  })

  // Druidcraft Bone Chestplate
  event.remove({id: 'druidcraft:bone_chestplate'})
  event.shaped(Item.of('druidcraft:bone_chestplate'), [
    'BFB',
    'BBB',
    'BBB'
  ], {
    B: 'minecraft:bone',
    F: 'kubejs:bone_fragment'
  })

  // Druidcraft Bone Leggings
  event.remove({id: 'druidcraft:bone_leggings'})
  event.shaped(Item.of('druidcraft:bone_leggings'), [
    'BBB',
    'BFB',
    'B B'
  ], {
    B: 'minecraft:bone',
    F: 'kubejs:bone_fragment'
  })

  // Druidcraft Bone Boots
  event.remove({id: 'druidcraft:bone_boots'})
  event.shaped(Item.of('druidcraft:bone_boots'), [
    '   ',
    'B B',
    'BFB'
  ], {
    B: 'minecraft:bone',
    F: 'kubejs:bone_fragment'
  })



  // Hoglin Helmet
  event.remove({id: 'craftandhunt:goat_upgraded_to_hoglin_helmet'})
  event.shaped(Item.of('craftandhunt:hoglin_helmet'), [
    'BBB',
    'B B',
    '   '
  ], {
    B: 'craftandhunt:hoglin_leather',
  })

  // Hoglin Chestplate
  event.remove({id: 'craftandhunt:goat_upgraded_to_hoglin_chestplate'})
  event.shaped(Item.of('craftandhunt:hoglin_chestplate'), [
    'B B',
    'BBB',
    'BBB'
  ], {
    B: 'craftandhunt:hoglin_leather',
  })

  // Hoglin Leggings
  event.remove({id: 'craftandhunt:goat_upgraded_to_hoglin_leggings'})
  event.shaped(Item.of('craftandhunt:hoglin_leggings'), [
    'BBB',
    'B B',
    'B B'
  ], {
    B: 'craftandhunt:hoglin_leather',
  })

  // Hoglin Boots
  event.remove({id: 'craftandhunt:goat_upgraded_to_hoglin_boots'})
  event.shaped(Item.of('craftandhunt:hoglin_boots'), [
    '   ',
    'B B',
    'B B'
  ], {
    B: 'craftandhunt:hoglin_leather',
  })



  // Druidcraft Bone Sword
  event.remove({id: 'druidcraft:bone_sword'})
  event.shaped(Item.of('druidcraft:bone_sword'), [
    ' B ',
    ' B ',
    'FSF'
  ], {
    B: 'minecraft:bone',
    S: '#forge:rods/wooden',
    F: 'kubejs:bone_fragment'
  })

  // Druidcraft Bone Pickaxe
  event.remove({id: 'druidcraft:bone_pickaxe'})
  event.shaped(Item.of('druidcraft:bone_pickaxe'), [
    'BBB',
    ' F ',
    ' S '
  ], {
    B: 'minecraft:bone',
    S: '#forge:rods/wooden',
    F: 'kubejs:bone_fragment'
  })

  // Druidcraft Bone Shovel
  event.remove({id: 'druidcraft:bone_shovel'})
  event.shaped(Item.of('druidcraft:bone_shovel'), [
    ' B ',
    ' F ',
    ' S '
  ], {
    B: 'minecraft:bone',
    S: '#forge:rods/wooden',
    F: 'kubejs:bone_fragment'
  })

  // Druidcraft Bone Axe
  event.remove({id: 'druidcraft:bone_axe'})
  event.shaped(Item.of('druidcraft:bone_axe'), [
    'BB ',
    'BF ',
    ' S '
  ], {
    B: 'minecraft:bone',
    S: '#forge:rods/wooden',
    F: 'kubejs:bone_fragment'
  })

  // Druidcraft Bone Hoe
  event.remove({id: 'druidcraft:bone_hoe'})
  event.shaped(Item.of('druidcraft:bone_hoe'), [
    'BB ',
    ' F ',
    ' S '
  ], {
    B: 'minecraft:bone',
    S: '#forge:rods/wooden',
    F: 'kubejs:bone_fragment'
  })

  // 2x Bone to 8x Bone Fragments
  event.shapeless(Item.of('kubejs:bone_fragment', 8), ['minecraft:bone', 'minecraft:bone'])

  // 8x Bone Fragments to 2x Bone
  event.shapeless(Item.of('minecraft:bone', 2), ['kubejs:bone_fragment', 'kubejs:bone_fragment', 'kubejs:bone_fragment', 'kubejs:bone_fragment', 'kubejs:bone_fragment', 'kubejs:bone_fragment', 'kubejs:bone_fragment', 'kubejs:bone_fragment'])


  // Connecting Glass
  event.remove({id: 'connectedglass:borderless_glass1'})
  event.shaped(Item.of('connectedglass:borderless_glass', 9), [
    'GGG',
    'GGG',
    'GGG'
  ], {
    G: 'minecraft:glass',
  })


  // Glass Wall
  event.shaped(Item.of('variant16x:glass_wall', 6), [
    ' C ',
    'GGG',
    'GGG'
  ], {
    G: '#forge:glass/colorless',
    C: 'minecraft:cobblestone_wall'
  });


});